--- Fl_Inputold.cxx	Sun Apr 11 01:38:00 2004
+++ Fl_Input.cxx	Thu Feb 24 01:00:00 2005
@@ -108,13 +108,15 @@
   case FL_Right:
     ascii = ctrl('F'); break;
   case FL_Page_Up:
-    repeat_num=5; //temporary hack
-                  //TODO: find number of lines in window and use it instead 5
+    fl_font(textfont(),textsize()); //ensure current font is set to ours
+    repeat_num=h()/fl_height(); // number of lines to scroll
+    if (!repeat_num) repeat_num=1;
   case FL_Up:
     ascii = ctrl('P'); break;
   case FL_Page_Down:
-    repeat_num=5; //temporary hack
-                  //TODO: find number of lines in window and use it instead 5
+    fl_font(textfont(),textsize());
+    repeat_num=h()/fl_height();
+    if (!repeat_num) repeat_num=1;
   case FL_Down:
     ascii = ctrl('N'); break;
   case FL_Home:
@@ -202,18 +204,20 @@
     return copy_cuts();
   case ctrl('N'):
     i = position();
+    if (line_end(i) >= size()) return NORMAL_INPUT_MOVE;
     while (repeat_num--) {  
       i = line_end(i);
-      if (i >= size()) return NORMAL_INPUT_MOVE;
+      if (i >= size()) break;
       i++;
     }
     shift_up_down_position(i);
     return 1;
   case ctrl('P'):
     i = position();
+    if (!line_start(i)) return NORMAL_INPUT_MOVE;
     while(repeat_num--) {
       i = line_start(i);
-      if (!i) return NORMAL_INPUT_MOVE;
+      if (!i) break;
       i--;
     }
     shift_up_down_position(line_start(i));
